import paho.mqtt.client as mqtt #import the client1
import time
from threading import Timer

enable_mqtt=0

#kodi1: ultraaquarial   303sec    moritz
#kodi2: umlaufmai      1485sec
#kodi3    pilger
#kodi4: paulina         179sec



seq=[
[10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[20,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[30,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[40,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0],
[50,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0],
]


videoseq=[
[15,1],
[25,2],
[35,3],
[45,4],
]


broker_address="10.0.0.2" 
#broker_address="iot.eclipse.org" #use external broker
client = mqtt.Client("P1") #create new instance
if enable_mqtt==1:
	client.connect(broker_address) #connect to broker
	client.subscribe("sequencer")
	client.on_message=on_message        #attach function to callback
	client.loop_start()    #start the loop

seqt=0
lasttime=0
currentidx=-1
currentvideoidx=0
lastevent=seq[0]

def on_message(client, userdata, message):
    print("message received " ,str(message.payload.decode("utf-8")))
    print("message topic=",message.topic)
    print("message qos=",message.qos)


def sendstat(t):
	mqttstr="seqstat",str(t)
	print(mqttstr)
	if enable_mqtt==1:
		client.publish(mqttstr)



def sendalloff():
	for s in range(0,22):
		mqttstr="cmnd/sonoff"+str(s)+"/POWER","OFF"
		print(mqttstr)
		if enable_mqtt==1:
			client.publish(mqttstr)

def sendon(s):
	mqttstr="cmnd/sonoff"+str(s)+"/POWER","ON"
	print(mqttstr)
	if enable_mqtt==1:
		client.publish(mqttstr)

def sendoff(s):
	mqttstr="cmnd/sonoff"+str(s)+"/POWER","OFF"
	print(mqttstr)
	if enable_mqtt==1:
		client.publish(mqttstr)

def sendvideostart(s):

	mqttstr="kodi"+str(s)+"/command/play","/home/osmc/video/video.mov"
	print(mqttstr)
	if enable_mqtt==1:
		client.publish(mqttstr)

def sendallstop():
	for s in range(1,7):
		mqttstr="kodi"+str(s)+"/command/playbackstate","0"
		print(mqttstr)
		if enable_mqtt==1:
			client.publish(mqttstr)


#timer class:
class seqTimer():
   def __init__(self,t,hFunction):
      self.t=t
      self.hFunction = hFunction
      self.thread = Timer(self.t,self.handle_function)

   def handle_function(self):
      self.hFunction()
      self.thread = Timer(self.t,self.handle_function)
      self.thread.start()

   def start(self):
      self.thread.start()

   def cancel(self):
      self.thread.cancel()


#1 sec timer event:
def timerevent():
	global seqt
	global seq
	global lasttime
	global lastvideotime
	global currentidx
	global lastevent
	global videoseq
	global currentvideoidx
	global videoseqcount 

	if seqt<lasttime: 
		seqt+=1
	else:
		seqt=0 
		currentidx=-1

	#print(seqt)
	sendstat(seqt)
	if seqt==seq[currentidx+1][0]:
		currentidx+=1
		print("have event",seq[currentidx])
		for i in range(1,22):
			if seq[currentidx][i]!=lastevent[i]:
				#print(i,"changed")
				if seq[currentidx][i]==1:
					sendon(i-1)
				else:
					sendoff(i-1)

		lastevent=seq[currentidx]

	if seqt==videoseq[currentvideoidx][0]:
		print("have video event",videoseq[currentvideoidx])
		sendvideostart(videoseq[currentvideoidx][1])
		if currentvideoidx<videoseqcount-1:
			currentvideoidx+=1
		else:
			currentvideoidx=0
		


seqcount=len(seq)
videoseqcount=len(videoseq)

lasttime=seq[seqcount-1][0]


print(seqcount,lasttime)

sendalloff()
sendallstop()


t = seqTimer(1,timerevent)
t.start()





#lights=[0,1,2,3,4,5,6,7,8,9,10,11,16,17,18,19]

#while True:
#	for state in range(0,seqcount):	
#		client.publish("cmnd/sonoff"+str(lights[i])+"/POWER","ON")#publish
		#client.publish("cmnd/sonoff1/POWER","OFF")#publish
#		time.sleep(.5)
#		client.publish("cmnd/sonoff"+str(lights[i])+"/POWER","OFF")#publish
		#client.publish("cmnd/sonoff1/POWER","ON")#publish
#		time.sleep(.5)
